﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Clients.Hive.CloudManager.Model {
  public class RoleInstance : Item {
    public string RoleName { get; set; }
    public string InstanceName { get; set; }
    public string InstanceStatus { get; set; }

    public RoleInstance() {

    }

    public RoleInstance(RoleInstance original, Cloner cloner) {
      this.RoleName = original.RoleName;
      this.InstanceName = original.InstanceName;
      this.InstanceStatus = original.InstanceStatus;
    }

    public override bool Equals(object obj) {
      if (obj == null)
        return false;
      RoleInstance ri = obj as RoleInstance;
      if ((this.RoleName == ri.RoleName))
        return true;
      else
        return false;
    }

    public override string ToString() {
      return string.Format("RoleInstance: Name={0}, InstanceName={1}, InstanceStatus={2}", RoleName, InstanceName, InstanceStatus);
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new RoleInstance(this, cloner);
    }
  }
}
